totalNumber <- 25	#vC[̑
groupNumber <- 5	#Wc̐
repeatNumber <- 10000	#JԂs̉
contribution <- 2	#Public Accountւ̋oz
multiplier <- 2	#Public AccountɋoƂvz̉{邩
deltaBad <- 0.25	#Ԃ̂Ƃ̊q
deltaGood <- 0.75	#悢Ԃ̂Ƃ̊q
punishment <- 1	#̌ʂPl
costOfPunishment <- 1	#lЂƂ̔̔pij^ORXgj

meanPayoffS <- numeric(totalNumber)	#Strong Reciprocator(S헪)̕ϗ
meanPayoffN <- numeric(totalNumber)	#Non-strong Reciprocator(N헪)̕ϗ

members <- totalNumber/groupNumber #1Wc̃vC[
cooperation <- contribution*(multiplier-1)/(1-deltaBad) #ԂŏWc̑S͂Ƃ̗
cooperationGood <- contribution*(multiplier-1)/(1-deltaGood) #悢ԂŏWc̑S͂Ƃ̗
defection <- (members-1)*multiplier*contribution/members #1lEꍇ̂̐l̗

#G[bZ[W
if(members != ceiling(members)){
	stop("1Wc̃vC[ɂȂĂ܂B")
}
if(multiplier <= 1 || multiplier > members){
	stop("muliplier̐ݒ肪K؂ł͂܂B")	#Nll̃W}ɂȂ邽߂ɂ́A1<multiplier<membersłKv
}
if(cooperationGood < defection){
	stop("̐ݒł́A悢Ԃł͂܂B")
}
if(cooperation > defection){
	stop("̐ݒł́AԂłS헪Ȃŋ͂܂B")
}

# S1l̂ƂA2l̂ƂccAƏԂɌvZ		
for(numberOfS in 1:totalNumber){
sumPayoffS <- 0		#S̗̍viJԂ݌vj
sumPayoffN <- 0		#N̗̍viJԂ݌vj
    
	for(i in 1:repeatNumber){
		set <- sample(totalNumber, numberOfS)	#S̔zu_Ɍ߂
		strategy <- numeric(totalNumber)
		strategy[set] <- 1						#SȂ1, NȂ0U
		#Wcɕis11WcɁj
		group <- matrix(strategy, nrow=members, ncol=groupNumber)	
		colMean <- colMeans(group)	#ꂼ̏WcS̊
		
		for(j in 1:groupNumber){
			if(colMean[j]==1){
				punishedDefection <- 0 #SS헪̑gł͖ɋ͂
			}
			else{
				punishedDefection <- defection - punishment*colMean[j]/(1-colMean[j])
			}
			if(cooperation >= punishedDefection){		#񋦗͂ŔꂽƂ̗͂菭ȂȂS
				colGroup <- group[,j]	#1̏Wco
				sumPayoffS <- sumPayoffS + (cooperation - costOfPunishment)*length(colGroup[colGroup==1])
				sumPayoffN <- sumPayoffN + cooperation*length(colGroup[colGroup==0])
			}		
		}
	}
	
meanPayoffS[numberOfS] <- sumPayoffS/numberOfS
meanPayoffN[numberOfS] <- sumPayoffN/(totalNumber-numberOfS)
}

#ʂOt
proportionOfS <- (1:totalNumber)/totalNumber

#SN̕ϗ̃Ot
plot(proportionOfS, meanPayoffS/repeatNumber, ylim=c(0,cooperation), type="l", xlab="S̊", ylab="ϗ")
lines(proportionOfS, meanPayoffN/repeatNumber, type="l", ylim=c(0,cooperation), lty=2, xlab="", ylab="")
legend(0.1, 2.5, lty=1:2, c("S", "N"))